<?php

declare(strict_types=1);

namespace FiloBlu\Refilo\Plugins\Api;

use Magento\Sales\Api\OrderRepositoryInterface;
use Magento\Framework\Api\SearchCriteriaInterface;
use Magento\Sales\Api\Data\OrderSearchResultInterface;
use Magento\Sales\Api\Data\OrderExtensionFactory;

class AfterGetList
{
    /**
     * @var OrderExtensionFactory
     */
    protected $orderExtensionFactory;

    public function __construct(
        OrderExtensionFactory $orderExtensionFactory
    ) {
        $this->orderExtensionFactory = $orderExtensionFactory;
    }

    /**
     * @param OrderRepositoryInterface $subject
     * @param OrderSearchResultInterface $searchResult
     * @return OrderSearchResultInterface
     */
    public function afterGetList(
        OrderRepositoryInterface $subject,
        OrderSearchResultInterface $searchResult
    ) {
        foreach ($searchResult->getItems() as $order) {
            $extensionAttributes = $order->getExtensionAttributes() ?: $this->orderExtensionFactory->create();

            $extensionAttributes->setData('coupon_code', $order->getCouponCode());

            $order->setExtensionAttributes($extensionAttributes);
        }

        return $searchResult;
    }
}
